(MODULE
 BATCH-LEONARD
 (WITH
  QOBISCHEME
  XLIB
  HLIB-CHANGE-MOVIE
  HLIB-EM
  HLIB-FIND-LINES
  HLIB-HULL
  HLIB-INTERPRET
  HLIB-KINEMATIC
  HLIB-LOCATE
  HLIB-MERGE-LINES
  HLIB-MOST
  HLIB-POSTSCRIPT
  HLIB-RATIO-REGIONS
  HLIB-RILIB
  HLIB-SDE
  HLIB-SNAKE
  HLIB-SPAN
  HLIB-SPEAK
  HLIB-TRACK
  HLIB-TRAIN-CLASSIFY
  HLIB-WBM)
 (MAIN MAIN))
;;; LaHaShem HaAretz U'Mloah

(include "QobiScheme.sch")
(include "batch-leonard.sch")
(include "c-externals.sc")

(set! *program* "batch-leonard")
(set! *panic?* #t)

;;; Variables

(define *fill* #f)
(define *x-weight* #f)
(define *y-weight* #f)
(define *a-weight* #f)
(define *correspondence-threshold* #f)
(define *red?* #f)
(define *green?* #f)
(define *blue?* #f)
(define *yellow?* #f)
(define *rhl* 13)
(define *rhh* 336)
(define *rsl* 36)
(define *rsh* 74)
(define *rvl* 35)
(define *rvh* 70)
(define *ghl* 122)
(define *ghh* 164)
(define *gsl* 29)
(define *gsh* 71)
(define *gvl* 22)
(define *gvh* 55)
(define *bhl* 192)
(define *bhh* 227)
(define *bsl* 32)
(define *bsh* 66)
(define *bvl* 27)
(define *bvh* 61)
(define *yhl* 50)
(define *yhh* 70)
(define *ysl* 40)
(define *ysh* 65)
(define *yvl* 55)
(define *yvh* 80)
(define *meteor-motion-threshold* 24)
(define *meteor-colour-pixel-mass-threshold* 60)
(define *meteor-colour-proximity-threshold* 4)
(define *meteor-motion-pixel-mass-threshold* 200)
(define *meteor-motion-proximity-threshold* 8)

;;; Top Level

(define-command
 (main (at-most-one ("rgby" rgby? (rgby "pathname" string-argument "rgby")))
       (at-most-one ("fill" fill? (fill "#" integer-argument 5)))
       (at-most-one ("x-weight" x-weight? (x-weight "#" real-argument 1.0)))
       (at-most-one ("y-weight" y-weight? (y-weight "#" real-argument 1.0)))
       (at-most-one ("a-weight" a-weight? (a-weight "#" real-argument 1.0)))
       (at-most-one ("correspondence-threshold"
		     correspondence-threshold?
		     (correspondence-threshold "#" real-argument 0.15)))
       (at-most-one ("cache" cache?))
       (at-most-one ("fast" fast?) ("cheap" cheap?))
       (at-most-one ("twice" twice?))
       (at-most-one ("new-temporal-circumscription-cost"
		     new-temporal-circumscription-cost?))
       (at-most-one ("new-indexing" new-indexing?))
       (at-most-one
	("event-definition-set-name"
	 event-definition-set-name?
	 (event-definition-set-name "type" string-argument "default")))
       (at-most-one ("delta" delta? (delta "#" integer-argument 2)))
       (at-most-one ("fuzz" fuzz? (fuzz "#" integer-argument 0)))
       (at-most-one ("jair2001" jair2001?))
       (required (pathname "pathname" string-argument)))
 (when jair2001?
  (set! fill? #f)
  (set! fill 5)
  (set! x-weight? #f)
  (set! x-weight 1.0)
  (set! y-weight? #f)
  (set! y-weight 1.0)
  (set! a-weight? #f)
  (set! a-weight 1.0)
  (set! correspondence-threshold? #f)
  (set! correspondence-threshold 0.15)
  (set! cache? #f)
  (set! fast? #f)
  (set! cheap? #f)
  (set! twice? #f)
  (set! new-temporal-circumscription-cost? #f)
  (set! new-indexing? #f)
  (set! event-definition-set-name "jair2001")
  (set! delta 2)
  (set! fuzz 0)
  (set! *jair2001-bug?* #t))
 (set! *width* 320)
 (set! *height* 240)
 (set! *cache?* cache?)
 (set! *fast?* (or fast? cheap?))
 (set! *cheap?* cheap?)
 (set! *new-temporal-circumscription-cost?* new-temporal-circumscription-cost?)
 (unless (member event-definition-set-name '("jair2001" "debugging" "default"))
  (panic "Unknown event-defintion--set name"))
 (set! *event-definition-set-name* event-definition-set-name)
 (set! *delta* delta)
 (set! *fuzz* fuzz)
 (set! *red?* #t)
 (set! *green?* #t)
 (set! *blue?* #t)
 (set! *yellow?* #t)
 (when rgby?
  (let ((rgby (read-object-from-file (default-extension rgby "rgby"))))
   (set! *red?* (first (first rgby)))
   (set! *rhl* (second (first rgby)))
   (set! *rhh* (third (first rgby)))
   (set! *rsl* (fourth (first rgby)))
   (set! *rsh* (fifth (first rgby)))
   (set! *rvl* (sixth (first rgby)))
   (set! *rvh* (seventh (first rgby)))
   (set! *green?* (first (second rgby)))
   (set! *ghl* (second (second rgby)))
   (set! *ghh* (third (second rgby)))
   (set! *gsl* (fourth (second rgby)))
   (set! *gsh* (fifth (second rgby)))
   (set! *gvl* (sixth (second rgby)))
   (set! *gvh* (seventh (second rgby)))
   (set! *blue?* (first (third rgby)))
   (set! *bhl* (second (third rgby)))
   (set! *bhh* (third (third rgby)))
   (set! *bsl* (fourth (third rgby)))
   (set! *bsh* (fifth (third rgby)))
   (set! *bvl* (sixth (third rgby)))
   (set! *bvh* (seventh (third rgby)))
   (set! *yellow?* (first (fourth rgby)))
   (set! *yhl* (second (fourth rgby)))
   (set! *yhh* (third (fourth rgby)))
   (set! *ysl* (fourth (fourth rgby)))
   (set! *ysh* (fifth (fourth rgby)))
   (set! *yvl* (sixth (fourth rgby)))
   (set! *yvh* (seventh (fourth rgby)))
   (set! *meteor-motion-threshold* (first (fifth rgby)))
   (set! *meteor-colour-pixel-mass-threshold* (second (fifth rgby)))
   (set! *meteor-colour-proximity-threshold* (third (fifth rgby)))
   (set! *meteor-motion-pixel-mass-threshold* (fourth (fifth rgby)))
   (set! *meteor-motion-proximity-threshold* (fifth (fifth rgby)))
   (meteor-set-red-hack-track!
    *rhl* *rhh* (if *red?* *rsl* 101) *rsh* *rvl* *rvh*)
   (meteor-set-green-hack-track!
    *ghl* *ghh* (if *green?* *gsl* 101) *gsh* *gvl* *gvh*)
   (meteor-set-blue-hack-track!
    *bhl* *bhh* (if *blue?* *bsl* 101) *bsh* *bvl* *bvh*)
   (meteor-set-yellow-hack-track!
    *yhl* *yhh* (if *yellow?* *ysl* 101) *ysh* *yvl* *yvh*)
   (meteor-set-hack-track! *meteor-motion-threshold*
			   *meteor-colour-pixel-mass-threshold*
			   *meteor-colour-proximity-threshold*
			   *meteor-motion-pixel-mass-threshold*
			   *meteor-motion-proximity-threshold*)))
 (set! *fill* fill)
 (set! *x-weight* x-weight)
 (set! *y-weight* y-weight)
 (set! *a-weight* a-weight)
 (set! *correspondence-threshold* correspondence-threshold)
 (set! *kinematic-models-cache* '())
 (set! *display* (xopendisplay *display-name*))
 (when (null-pointer? *display*)
  (panic "Cannot connect to X server: ~a" (xdisplayname *display-name*)))
 (set! *screen* (xdefaultscreen *display*))
 (set! *root-window* (xrootwindow *display* *screen*))
 (set! *background*
       (xallocnamedcolor *display*
			 (xdefaultcolormap *display* *screen*)
			 *background-color*))
 (unless (= (first *background*) 1)
  (panic "Can't allocate background colorcell"))
 (set! *foreground*
       (xallocnamedcolor *display*
			 (xdefaultcolormap *display* *screen*)
			 *foreground-color*))
 (unless (= (first *foreground*) 1)
  (panic "Can't allocate foreground colorcell"))
 (set! *roman-font* (xloadqueryfont *display* *roman-font-name*))
 (when (null-pointer? *roman-font*)
  (panic "Cannot open font: ~a" *roman-font-name*))
 (set! *window*
       (xcreatesimplewindow *display* *root-window* 0 0 1 1 1
			    (xcolor-pixel (second *foreground*))
			    (xcolor-pixel (second *background*))))
 (set! *display-pane* *window*)
 (set! *thin-gc* (xcreategc *display* *window* 0 (make-xgcvalues)))
 (xsetbackground *display* *thin-gc* (xcolor-pixel (second *background*)))
 (xsetforeground *display* *thin-gc* (xcolor-pixel (second *foreground*)))
 (xsetlineattributes *display* *thin-gc* 0 linesolid capround joinround)
 (set! *medium-gc* (xcreategc *display* *window* 0 (make-xgcvalues)))
 (xsetbackground
  *display* *medium-gc* (xcolor-pixel (second *background*)))
 (xsetforeground
  *display* *medium-gc* (xcolor-pixel (second *foreground*)))
 (xsetlineattributes *display* *medium-gc* 2 linesolid capround joinround)
 (set! *roman-gc* (xcreategc *display* *window* 0 (make-xgcvalues)))
 (xsetbackground
  *display* *roman-gc* (xcolor-pixel (second *background*)))
 (xsetforeground
  *display* *roman-gc* (xcolor-pixel (second *foreground*)))
 (xsetfont *display* *roman-gc* (xfontstruct-fid *roman-font*))
 (set! *color-gc* (xcreategc *display* *window* 0 (make-xgcvalues)))
 (xsetbackground
  *display* *color-gc* (xcolor-pixel (second *background*)))
 (xsetforeground
  *display* *color-gc* (xcolor-pixel (second *foreground*)))
 (xsetlineattributes *display* *color-gc* 0 linesolid capround joinround)
 (cond
  ((and (has-extension? pathname)
	(string=? (extension pathname) "polygon-movie"))
   (set! *polygon-movie* (read-object-from-file pathname))
   (set! *colours* #f)
   (when (can-open-file-for-input? (replace-extension pathname "colours"))
    (set! *colours*
	  (read-object-from-file (replace-extension pathname "colours")))))
  (else
   (let ((polygon-movie
	  (convex-hull-of-polygon-movie
	   (second (meteor-track-video-file
		    pathname
		    (if (has-extension? pathname) (extension pathname) "Jpeg")
		    #t
		    #t
		    #f
		    #f
		    #t
		    #t
		    #f
		    *meteor-motion-threshold*
		    *meteor-colour-pixel-mass-threshold*
		    *meteor-colour-proximity-threshold*
		    *meteor-motion-pixel-mass-threshold*
		    *meteor-motion-proximity-threshold*)))))
    ;; SET! of *COLOURS* has to come before SET! of *POLYGON-MOVIE* because
    ;; POLYGON-CORRESPONDENCE may reorder the polygons in a frame so they no
    ;; longer correspond to the order used by GET-OBJECT-COLOUR.
    (set! *colours*
	  (map-n-vector
	   (lambda (t)
	    (map-n (lambda (i)
		    (list (matrix-ref polygon-movie t i)
			  (get-object-colour t i)))
		   (vector-length (vector-ref polygon-movie t))))
	   (vector-length polygon-movie)))
    (set! *polygon-movie*
	  (map-vector
	   (lambda (frame) (map list->vector frame))
	   (polygon-correspondence
	    (map-vector
	     (lambda (frame) (map vector->list (vector->list frame)))
	     polygon-movie)
	    *fill*
	    *x-weight*
	    *y-weight*
	    *a-weight*
	    *correspondence-threshold*)))
    (set! *colours*
	  (map-n-vector
	   (lambda (i)
	    (vector-ref
	     '#(moving red green blue yellow)
	     (mode
	      (removeq
	       #f
	       (map-n
		(lambda (t)
		 (if (assoc (list-ref (vector-ref *polygon-movie* t) i)
			    (vector-ref *colours* t))
		     (second (assoc (list-ref (vector-ref *polygon-movie* t) i)
				    (vector-ref *colours* t)))
		     #f))
		(vector-length *polygon-movie*))))))
	   (length (vector-ref *polygon-movie* 0)))))
   (write-object-to-file
    *polygon-movie* (replace-extension pathname "polygon-movie"))))
 (let ((preferred-models-movie
	(map-vector forward-simplified-minimal-polygon-kinematic-models
		    *polygon-movie*)))
  (when (some-vector null? preferred-models-movie)
   (panic "No preferred models"))
  (let ((more-preferred-models-movie
	 (if twice?
	     (map-vector
	      (lambda (preferred-models ground?)
	       (cardinality-circumscription
		(remove-if-not
		 (lambda (preferred-model)
		  (equal? (kinematic-model-ground? preferred-model) ground?))
		 preferred-models)))
	      preferred-models-movie
	      (map-vector
	       (lambda (preferred-models)
		(kinematic-model-ground? (first preferred-models)))
	       (temporal-circumscription preferred-models-movie)))
	     (map-vector cardinality-circumscription preferred-models-movie))))
   (when (some-vector null? more-preferred-models-movie)
    (panic "No more-preferred models"))
   (set! *kinematic-models*
	 (temporal-circumscription more-preferred-models-movie))
   (for-each-n
    (lambda (i)
     (let ((frame (vector-ref *polygon-movie* i))
	   (preferred-models (vector-ref preferred-models-movie i))
	   (more-preferred-models (vector-ref more-preferred-models-movie i))
	   (most-preferred-model (first (vector-ref *kinematic-models* i))))
      (unless (and (has-extension? pathname)
		   (string=? (extension pathname) "polygon-movie"))
       ;; needs work: to convert frame-i-image.ppm to frame-i-image.ps
       (write-pnm
	(meteor-frame->ppm i)
	(replace-extension
	 (format #f "~a-~s-image" (strip-extension pathname) i) "ppm"))
       ;; needs work: to convert frame-i-code.ppm to frame-i-code.ps
       (write-pnm
	(meteor-code-frame->ppm i)
	(replace-extension
	 (format #f "~a-~s-code" (strip-extension pathname) i) "ppm")))
      (polygons->postscript
       frame (format #f "~a-~s-polygons" (strip-extension pathname) i))
      (write-object-to-file
       (list frame preferred-models)
       (replace-extension
	(format #f "~a-~s-preferred-models" (strip-extension pathname) i)
	"kgp"))
      (for-each-indexed (lambda (preferred-model j)
			 (kinematic-model->postscript
			  frame
			  preferred-model
			  (format #f "~a-~s-preferred-model-~s"
				  (strip-extension pathname) i j)))
			preferred-models)
      (write-object-to-file
       (list frame more-preferred-models)
       (replace-extension
	(format #f "~a-~s-more-preferred-models" (strip-extension pathname) i)
	"kgp"))
      (if new-indexing?
	  (for-each
	   (lambda (more-preferred-model)
	    (kinematic-model->postscript
	     frame
	     more-preferred-model
	     (format #f "~a-~s-more-preferred-model-~s"
		     (strip-extension pathname)
		     i
		     (position more-preferred-model preferred-models))))
	   more-preferred-models)
	  (for-each-indexed
	   (lambda (more-preferred-model j)
	    (kinematic-model->postscript
	     frame
	     more-preferred-model
	     (format #f "~a-~s-more-preferred-model-~s"
		     (strip-extension pathname) i j)))
	   more-preferred-models))
      (write-object-to-file
       (list frame (list most-preferred-model))
       (replace-extension
	(format #f "~a-~s-most-preferred-model" (strip-extension pathname) i)
	"kgp"))
      (if new-indexing?
	  (kinematic-model->postscript
	   frame
	   most-preferred-model
	   (format #f "~a-~s-most-preferred-model-~s"
		   (strip-extension pathname)
		   i
		   (position most-preferred-model preferred-models)))
	  (kinematic-model->postscript
	   frame
	   most-preferred-model
	   (format #f "~a-~s-most-preferred-model"
		   (strip-extension pathname) i)))
      (unless (and (has-extension? pathname)
		   (string=? (extension pathname) "polygon-movie"))
       ;; needs work: to convert frame-i-code-and-polygons.ppm to
       ;;             frame-i-code-and-polygons.ps
       (write-pnm
	(kinematic-model->ppm #t i frame #f)
	(replace-extension
	 (format #f "~a-~s-code-and-polygons" (strip-extension pathname) i)
	 "ppm"))
       ;; needs work: to convert frame-i-code-and-most-preferred-model.ppm to
       ;;             frame-i-code-and-most-preferred-model.ps
       (write-pnm (kinematic-model->ppm #t i frame most-preferred-model)
		  (replace-extension
		   (format #f "~a-~s-code-and-most-preferred-model"
			   (strip-extension pathname) i)
		   "ppm"))
       ;; needs work: to convert frame-i-image-and-polygons.ppm to
       ;;             frame-i-image-and-polygons.ps
       (write-pnm
	(kinematic-model->ppm #f i frame #f)
	(replace-extension
	 (format #f "~a-~s-image-and-polygons" (strip-extension pathname) i)
	 "ppm"))
       ;; needs work: to convert frame-i-image-and-most-preferred-model.ppm
       ;;             to frame-i-image-and-most-preferred-model.ps
       (write-pnm (kinematic-model->ppm #f i frame most-preferred-model)
		  (replace-extension
		   (format #f "~a-~s-image-and-most-preferred-model"
			   (strip-extension pathname) i)
		   "ppm")))))
    (vector-length *polygon-movie*))
   (precompute!)
   (call-with-output-file
     (default-extension
      (format #f "~a-events" (strip-extension pathname)) "text")
    (lambda (events)
     (for-effects
      (let* ((e (an-event (first (a-member-of (aggregate-event-types)))))
	     (is (occurrences-of e)))
       (unless (null? is)
	(display (format-event e is) events)
	(newline events))))
     (newline events)
     (for-effects
      (let ((e (either (list 'supported? (a-member-of (objects)))
		       (list 'supports?
			     (a-member-of (objects))
			     (a-member-of (objects)))
		       (list 'contacts?
			     (a-member-of (objects))
			     (a-member-of (objects)))
		       (list 'attached?
			     (a-member-of (objects))
			     (a-member-of (objects))))))
       (when (and (or (eq? (first e) 'contacts?) (eq? (first e) 'attached?))
		  (> (second e) (third e)))
	(fail))
       (let ((is (occurrences-of e)))
	(unless (null? is)
	 (display (format-event e is) events)
	 (newline events)))))))
   (meteor-shutdown-offline)))
 (xfreegc *display* *thin-gc*)
 (xfreegc *display* *medium-gc*)
 (xfreegc *display* *roman-gc*)
 (xfreegc *display* *color-gc*)
 (xfreecolors
  *display*
  (xdefaultcolormap *display* *screen*)
  (unsigned-list->unsigneda (list (xcolor-pixel (second *background*))))
  1
  0)
 (xfreecolors
  *display*
  (xdefaultcolormap *display* *screen*)
  (unsigned-list->unsigneda (list (xcolor-pixel (second *foreground*))))
  1
  0)
 (xunloadfont *display* (xfontstruct-fid *roman-font*))
 (xdestroywindow *display* *window*)
 (xclosedisplay *display*)
 #f)

;;; Tam V'Nishlam Shevah L'El Borei Olam
