(MODULE
 CAPTURE-TOOL
 (WITH
  QOBISCHEME
  XLIB
  HLIB-CHANGE-MOVIE
  HLIB-EM
  HLIB-FIND-LINES
  HLIB-HULL
  HLIB-INTERPRET
  HLIB-KINEMATIC
  HLIB-LOCATE
  HLIB-MERGE-LINES
  HLIB-MOST
  HLIB-POSTSCRIPT
  HLIB-RATIO-REGIONS
  HLIB-RILIB
  HLIB-SDE
  HLIB-SNAKE
  HLIB-SPAN
  HLIB-SPEAK
  HLIB-TRACK
  HLIB-TRAIN-CLASSIFY
  HLIB-WBM)
 (MAIN MAIN))
;;; LaHaShem HaAretz U'Mloah

(include "QobiScheme.sch")
(include "capture-tool.sch")
(include "c-externals.sc")

(set! *program* "capture-tool")
(set! *panic?* #t)

;;; Variables

(define *movies?* #f)
(define *pathname* #f)
(define *t* #f)
(define *end* #f)
(define *first-frame* #f)
(define *last-frame* #f)
(define *video-type* #f)
(define *size* #f)
(define *previous-width* #f)
(define *previous-height* #f)
(define *seconds* 1)
(define *uninterlaced?* #f)
(define *deinterlaced?* #f)
(define *mode* #f)
(define *sequel* #f)
(define *sequels* #f)

;;; Procedures

(define (video-type)
 (case *video-type*
  ((jpeg) "Jpeg")
  ((mpeg1) "Mpeg1")
  (else (fuck-up))))

(define (redraw!)
 (case *mode*
  ((viewfinder) #f)
  ((images)
   (meteor-show-frame
    (+ (inexact->exact (round (* *sequel* *seconds* *frame-rate*))) *t*)))
  (else (fuck-up)))
 (when *pathname*
  (xdrawstring
   *display* *display-pane* *roman-gc* 5 (- *display-pane-height* 5)
   *pathname* (string-length *pathname*))))

(define (capture!)
 (message "")
 (unless (eq? *mode* 'viewfinder)
  (set! *mode* 'viewfinder)
  (redraw-buttons)
  (redraw-display-pane))
 (meteor-turn-on-viewfinder! (if (eq? *size* 'size640x480) 2 1))
 (meteor-page-in-frames
  (inexact->exact (round (* *sequel* *seconds* *frame-rate*)))
  (inexact->exact (round (* (+ *sequel* 1) *seconds* *frame-rate*))))
 (xbell *display* 100)
 (xflush *display*)
 (interruptible-usleep 1000000)
 (xbell *display* 100)
 (xflush *display*)
 (interruptible-usleep 1000000)
 (xbell *display* 100)
 (xflush *display*)
 (interruptible-usleep 1000000)
 (xbell *display* 100)
 (xflush *display*)
 (interruptible-usleep 250000)
 (xbell *display* 100)
 (xflush *display*)
 (meteor-capture-frames
  (inexact->exact (round (* *sequel* *seconds* *frame-rate*)))
  (inexact->exact (round (/ 30.0 *frame-rate*)))
  (inexact->exact (round (* (+ *sequel* 1) *seconds* *frame-rate*))))
 (meteor-turn-on-viewfinder! (if (eq? *size* 'size640x480) 2 1))
 (xbell *display* 100)
 (xflush *display*)
 (set! *t* 0)
 (set! *end* (- (inexact->exact (round (* *seconds* *frame-rate*))) 1))
 (set! *first-frame* 0)
 (set! *last-frame* *end*)
 (set! *movies?* #t))

;;; Commands

(define (capture-command)
 (capture!)
 (meteor-turn-off!)
 (set! *mode* 'images)
 (redraw-buttons)
 (redraw-display-pane))

(define (play-command)
 (message "")
 (when (eq? *mode* 'viewfinder)
  (message "Can't do this in viewfinder mode")
  (abort))
 (for-each-n
  (lambda (t)
   (meteor-show-frame
    (+ (inexact->exact (round (* *sequel* *seconds* *frame-rate*)))
       *first-frame*
       t))
   (xflush *display*)
   (usleep (inexact->exact (round (/ 1000000.0 *frame-rate*)))))
  (+ (- *last-frame* *first-frame*) 1))
 (redraw-display-pane))

(define (beginning-command)
 (message "")
 (when (eq? *mode* 'viewfinder)
  (message "Can't do this in viewfinder mode")
  (abort))
 (unless (zero? *t*)
  (set! *t* 0)
  (redraw-buttons)
  (redraw-display-pane)))

(define (decrement-t-command)
 (message "")
 (when (eq? *mode* 'viewfinder)
  (message "Can't do this in viewfinder mode")
  (abort))
 (when (zero? *t*) (message "At beginning of movie") (abort))
 (set! *t* (- *t* 1))
 (redraw-buttons)
 (redraw-display-pane))

(define (increment-t-command)
 (message "")
 (when (eq? *mode* 'viewfinder)
  (message "Can't do this in viewfinder mode")
  (abort))
 (when (= *t* *end*) (message "At end of movie") (abort))
 (set! *t* (+ *t* 1))
 (redraw-buttons)
 (redraw-display-pane))

(define (end-command)
 (message "")
 (when (eq? *mode* 'viewfinder)
  (message "Can't do this in viewfinder mode")
  (abort))
 (unless (= *t* *end*)
  (set! *t* *end*)
  (redraw-buttons)
  (redraw-display-pane)))

(define (save-command)
 (message "")
 (unless *pathname* (message "No pathname") (abort))
 (meteor-frames->video-file
  (+ (inexact->exact (round (* *sequel* *seconds* *frame-rate*)))
     *first-frame*)
  (+ (inexact->exact (round (* *sequel* *seconds* *frame-rate*)))
     *last-frame*
     1)
  (replace-extension *pathname* (video-type))
  (video-type)))

;;; Top Level

(define-application viewer 640 500 0 5 6
 (lambda ()
  (set! *movies?* #f)
  (set! *video-type* 'jpeg)
  (set! *size* 'size320x240)
  (case *size*
   ((size640x480)
    (set! *width* 640)
    (set! *height* 480))
   ((size320x240)
    (set! *width* 320)
    (set! *height* 240))
   (else (fuck-up)))
  (set! *previous-width* *width*)
  (set! *previous-height* *height*)
  (set! *seconds* 4)
  (set! *uninterlaced?* #t)
  (set! *deinterlaced?* #f)
  (set! *mode* 'viewfinder)
  (set! *sequel* 0)
  (set! *sequels* 1)
  (define-button 0 0 "Capture" #f capture-command)
  (define-button 1 0 "Set First" #f
   (lambda ()
    (message "")
    (when (eq? *mode* 'viewfinder)
     (message "Can't do this in viewfinder mode")
     (abort))
    (set! *first-frame* *t*)
    (set! *last-frame* (max *last-frame* *first-frame*))
    (redraw-buttons)))
  (define-button 2 0 "Play" #f play-command)
  (define-button 3 0 "Save" #f save-command)
  (define-button 4 0 "Set Last" #f
   (lambda ()
    (message "")
    (when (eq? *mode* 'viewfinder)
     (message "Can't do this in viewfinder mode")
     (abort))
    (set! *last-frame* *t*)
    (set! *first-frame* (min *first-frame* *last-frame*))
    (redraw-buttons)))
  (define-button 5 0 "Quit" #f quit)
  (define-button 0 1 "Beginning" #f beginning-command)
  (define-button 1 1
   (lambda ()
    (if (eq? *mode* 'viewfinder) "First" (format #f "First ~s" *first-frame*)))
   #f
   (lambda ()
    (message "")
    (when (eq? *mode* 'viewfinder)
     (message "Can't do this in viewfinder mode")
     (abort))
    (unless (= *t* *first-frame*)
     (set! *t* *first-frame*)
     (redraw-buttons)
     (redraw-display-pane))))
  (define-button 2 1
   (lambda ()
    (if (eq? *mode* 'viewfinder) "-T" (format #f "-T ~s" *t*)))
   #f
   decrement-t-command)
  (define-button 3 1
   (lambda ()
    (if (eq? *mode* 'viewfinder) "+T" (format #f "+T ~s" *t*)))
   #f
   increment-t-command)
  (define-button 4 1
   (lambda ()
    (if (eq? *mode* 'viewfinder) "Last" (format #f "Last ~s" *last-frame*)))
   #f
   (lambda ()
    (message "")
    (when (eq? *mode* 'viewfinder)
     (message "Can't do this in viewfinder mode")
     (abort))
    (unless (= *t* *last-frame*)
     (set! *t* *last-frame*)
     (redraw-buttons)
     (redraw-display-pane))))
  (define-button 5 1 "End" #f end-command)
  (define-radio-buttons *video-type* (lambda () (message ""))
   (0 2 jpeg "Jpeg")
   (1 2 mpeg1 "Mpeg1"))
  (define-radio-buttons *size*
   (lambda ()
    (message "")
    (set! *movies?* #f)
    (set! *mode* 'viewfinder)
    (case *size*
     ((size640x480)
      (set! *width* 640)
      (set! *height* 480))
     ((size320x240)
      (set! *width* 320)
      (set! *height* 240))
     (else (fuck-up)))
    (unless (and (= *width* *previous-width*) (= *height* *previous-height*))
     (meteor-restartup
      *height*
      *width*
      (inexact->exact (round (* *sequels* *seconds* *frame-rate*)))
      *uninterlaced?*)
     (set! *previous-width* *width*)
     (set! *previous-height* *height*))
    (redraw-buttons)
    (redraw-display-pane)
    (meteor-turn-on-viewfinder! (if (eq? *size* 'size640x480) 2 1)))
   (2 2 size640x480 "640x480")
   (3 2 size320x240 "320x240"))
  (define-integer-range-buttons 4 2 5 2 *seconds* 1 10
   (lambda () (format #f "-sec ~s" *seconds*))
   (lambda () (format #f "+sec ~s" *seconds*))
   (lambda ()
    (message "")
    (set! *movies?* #f)
    (set! *mode* 'viewfinder)
    (meteor-free)
    (meteor-malloc
     (inexact->exact (round (* *sequels* *seconds* *frame-rate*))))
    (redraw-buttons)
    (redraw-display-pane)
    (meteor-turn-on-viewfinder! (if (eq? *size* 'size640x480) 2 1))))
  (define-radio-buttons *mode*
   (lambda ()
    (message "")
    (unless *movies?*
     (set! *mode* 'viewfinder)
     (redraw-buttons)
     (message "No movies")
     (abort))
    (cond ((eq? *mode* 'viewfinder)
	   (redraw-display-pane)
	   (meteor-turn-on-viewfinder! (if (eq? *size* 'size640x480) 2 1)))
	  (else (meteor-turn-off!)
		(redraw-display-pane))))
   (0 3 viewfinder "Viewfinder")
   (1 3 images "Images"))
  (define-integer-range-buttons 2 3 3 3 *sequels* 1 40
   (lambda () (format #f "-sequels ~s" *sequels*))
   (lambda () (format #f "+sequels ~s" *sequels*))
   (lambda ()
    (set! *movies?* #f)
    (set! *mode* 'viewfinder)
    (set! *sequel* (min *sequel* (- *sequels* 1)))
    (meteor-free)
    (meteor-malloc
     (inexact->exact (round (* *sequels* *seconds* *frame-rate*))))
    (redraw-buttons)
    (redraw-display-pane)
    (meteor-turn-on-viewfinder! (if (eq? *size* 'size640x480) 2 1))))
  (define-button 4 3 (lambda () (format #f "-sequel ~s" *sequel*)) #f
   (lambda ()
    (message "")
    (when (zero? *sequel*) (message "First sequel") (abort))
    (set! *sequel* (- *sequel* 1))
    (redraw-buttons)
    (redraw-display-pane)))
  (define-button 5 3 (lambda () (format #f "+sequel ~s" *sequel*)) #f
   (lambda ()
    (message "")
    (when (= *sequel* (- *sequels* 1)) (message "Last sequel") (abort))
    (set! *sequel* (+ *sequel* 1))
    (redraw-buttons)
    (redraw-display-pane)))
  (define-toggle-button 0 4 "Uninterlace" *uninterlaced?*
   (lambda ()
    (message "")
    (set! *movies?* #f)
    (set! *mode* 'viewfinder)
    (redraw-buttons)
    (redraw-display-pane)
    (meteor-restartup
     *height*
     *width*
     (inexact->exact (round (* *sequels* *seconds* *frame-rate*)))
     *uninterlaced?*)
    (meteor-turn-on-viewfinder! (if (eq? *size* 'size640x480) 2 1))))
  (define-toggle-button 1 4 "Deinterlace" *deinterlaced?*
   (lambda ()
    (message "")
    (meteor-set-deinterlaced! *deinterlaced?*)
    (redraw-display-pane)))
  (define-button 2 4 "Snapshot" #f
   (lambda ()
    (unless *pathname* (message "No pathname") (abort))
    (meteor-page-in-frames 0 1)
    (meteor-capture-frames 0 1 1)
    (meteor-turn-on-viewfinder! (if (eq? *size* 'size640x480) 2 1))
    (write-pnm (meteor-frame->ppm 0) (default-extension *pathname* "ppm"))))
  (define-button 4 4 "Save All" #f
   (lambda ()
    (message "")
    (unless *pathname* (message "No pathname") (abort))
    (for-each-n
     (lambda (sequel)
      (meteor-frames->video-file
       (inexact->exact (round (* sequel *seconds* *frame-rate*)))
       (inexact->exact (round (* (+ sequel 1) *seconds* *frame-rate*)))
       (replace-extension (format #f "~a~a"
				  *pathname*
				  (number->padded-string-of-length sequel 2))
			  (video-type))
       (video-type)))
     *sequels*)))
  (define-button 5 4 "Capture All" #f
   (lambda ()
    (message "")
    (unless (eq? *mode* 'viewfinder)
     (set! *mode* 'viewfinder)
     (redraw-buttons)
     (redraw-display-pane))
    (meteor-turn-on-viewfinder! (if (eq? *size* 'size640x480) 2 1))
    (for-each-n (lambda (sequel)
		 (set! *sequel* sequel)
		 (redraw-buttons)
		 (interruptible-usleep (* 15 1000000))
		 (capture!))
		*sequels*)
    (set! *sequel* 0)
    (meteor-turn-off!)
    (set! *mode* 'images)
    (redraw-buttons)
    (redraw-display-pane)))
  (define-key (control #\c) "Capture" capture-command)
  (define-key (meta #\f) "Increment T" increment-t-command)
  (define-key (meta #\b) "Decrement T" decrement-t-command)
  (define-key (control #\p) "Play" play-command)
  (define-key (list (control #\x) (control #\c)) "Quit" quit)
  (define-key (list (control #\x) (control #\s)) "Save" save-command)
  (define-key (meta #\<) "Beginning" beginning-command)
  (define-key (meta #\>) "End" end-command)
  (meteor-startup-with-viewfinder
   *height*
   *width*
   (inexact->exact (round (* *sequels* *seconds* *frame-rate*)))
   *uninterlaced?*))
 (lambda () (meteor-turn-on-viewfinder! (if (eq? *size* 'size640x480) 2 1)))
 meteor-shutdown
 redraw!
 (lambda ()
  (set! *pathname* (and (not (string=? *input* "")) (strip-extension *input*)))
  (redraw-display-pane)))

(define-command (main (at-most-one ("fps" fps? (fps "#" real-argument 30.0)))
		      (optional (pathname "pathname" string-argument #f)))
 (set! *frame-rate* fps)
 (let ((downsample-factor (/ 30.0 *frame-rate*)))
  (unless (< (abs (- downsample-factor (round downsample-factor))) 0.001)
   (panic "Frame rate does not yield an integral downsample factor")))
 (set! *pathname* (and pathname (strip-extension pathname)))
 (viewer '()))

;;; Tam V'Nishlam Shevah L'El Borei Olam
