(MODULE
 EVENT-LOGIC
 (WITH
  QOBISCHEME
  XLIB
  HLIB-CHANGE-MOVIE
  HLIB-EM
  HLIB-FIND-LINES
  HLIB-HULL
  HLIB-INTERPRET
  HLIB-KINEMATIC
  HLIB-LOCATE
  HLIB-MERGE-LINES
  HLIB-MOST
  HLIB-POSTSCRIPT
  HLIB-RATIO-REGIONS
  HLIB-RILIB
  HLIB-SDE
  HLIB-SNAKE
  HLIB-SPAN
  HLIB-SPEAK
  HLIB-TRACK
  HLIB-TRAIN-CLASSIFY
  HLIB-WBM)
 (MAIN MAIN))
;;; LaHaShem HaAretz U'Mloah

(include "QobiScheme.sch")
(include "event-logic.sch")
(include "c-externals.sc")

(set! *program* "event-logic")
(set! *panic?* #t)

;;; Top Level

(define-command
 (main (at-most-one ("fast" fast?) ("cheap" cheap?))
       (at-most-one
	("event-definition-set-name"
	 event-definition-set-name?
	 (event-definition-set-name "type" string-argument "default")))
       (at-most-one ("delta" delta? (delta "#" integer-argument 2)))
       (at-most-one ("fuzz" fuzz? (fuzz "#" integer-argument 0)))
       (at-most-one ("jair2001" jair2001?))
       (required (pathname "pathname" string-argument)))
 (when jair2001?
  (set! fast? #f)
  (set! cheap? #f)
  (set! event-definition-set-name "jair2001")
  (set! delta 2)
  (set! fuzz 0)
  (set! *jair2001-bug?* #t))
 (set! *width* 320)
 (set! *height* 240)
 (set! *fast?* (or fast? cheap?))
 (set! *cheap?* cheap?)
 (unless (member event-definition-set-name '("jair2001" "debugging" "default"))
  (panic "Unknown event-defintion--set name"))
 (set! *event-definition-set-name* event-definition-set-name)
 (set! *delta* delta)
 (set! *fuzz* fuzz)
 (set! *kinematic-models-cache* '())
 (set! *polygon-movie*
       (read-object-from-file (replace-extension pathname "polygon-movie")))
 (set! *colours* #f)
 (when (can-open-file-for-input? (replace-extension pathname "colours"))
  (set! *colours*
	(read-object-from-file (replace-extension pathname "colours"))))

 (set! *kinematic-models*
       (let loop ((models '()) (frame 0))
	(let ((pathname (replace-extension
			 (format #f "~a-~s-most-preferred-model"
				 (strip-extension pathname) frame)
			 "kgp")))
	 (if (can-open-file-for-input? pathname)
	     (loop (cons (second (read-object-from-file pathname)) models)
		   (+ frame 1))
	     (list->vector (reverse models))))))
 (precompute!)
 (call-with-output-file
   (default-extension
    (format #f "~a-events" (strip-extension pathname)) "text")
  (lambda (events)
   (for-effects
    (let* ((e (an-event (first (a-member-of (aggregate-event-types)))))
	   (is (occurrences-of e)))
     (unless (null? is)
      (display (format-event e is) events)
      (newline events))))
   (newline events)
   (for-effects
    (let ((e (either (list 'supported? (a-member-of (objects)))
		     (list 'supports?
			   (a-member-of (objects))
			   (a-member-of (objects)))
		     (list 'contacts?
			   (a-member-of (objects))
			   (a-member-of (objects)))
		     (list 'attached?
			   (a-member-of (objects))
			   (a-member-of (objects))))))
     (when (and (or (eq? (first e) 'contacts?) (eq? (first e) 'attached?))
		(> (second e) (third e)))
      (fail))
     (let ((is (occurrences-of e)))
      (unless (null? is)
       (display (format-event e is) events)
       (newline events))))))))

;;; Tam V'Nishlam Shevah L'El Borei Olam
