/* Lahashem Haaretz U'Mloah */

#include <math.h>
#include <malloc.h>
#include <stdlib.h>
#include <stdio.h>
#include <stdarg.h>
#include "hlib-c.h"

/* needs work: snake_set_height_width, snake_free_all, and snake_e prefixed to
               avoid name conflicts */

#define aDEBUG
#define INFINITY (1.0/0.0)
#ifndef MIN
#define MIN(a, b) ((a)>(b)?(b):(a))
#endif
#ifndef MAX
#define MAX(a, b) ((a)>(b)?(a):(b))
#endif
#define sqr(a) ((a)*(a))

/* structures */

struct iteration_point
{ float min_energy;
  int *x_points_place;
  int *y_points_place;};

/* global variables */

int gheight, gwidth, **gpgm, gii, *gcontour_y, *gcontour_x;

/* prototypes */

void rotate_array(int *array, int number_to_move, int array_size);
void copy_array(int array_size, int *array_dest, int* array_src);
float pass_best_option_to_contour(struct iteration_point *last_points,
				  int number_of_options);
void print_contour(void);
void snake_set_height_width(int height, int width);
void set_pixel(int y, int x, int pixel);
void set_ii(int ii);
void set_contour(int k, int y, int x);
int get_contour_x(int k);
int get_contour_y(int k);
void snake_free_all(void);
float del_i_y(int y, int x);
float del_i_x(int y, int x);
float edge_directed(int y0, int x0, int y1, int x1);
float edge(int y0, int x0, int y1, int x1);
float econ(int y0, int x0, int y1, int x1, float average_length);
float eline(int y0, int x0, int y1, int x1);
float e(int y0, int x0, int y1, int x1, int y2, int x2,
	float c_edge_directed, float c_edge, float c_econ, float c_eline,
	float average_length);
float c_open_step(int width, int height, float c_edge_directed, float c_edge,
		  float c_econ, float c_eline, float average_length);
float c_open_snake(int width, int height, float c_edge_directed, float c_edge,
		   float c_econ, float c_eline, float average_length);
float c_closed_snake(int width, int height,
		     float c_edge_directed, float c_edge,
		     float c_econ, float c_eline, float average_length);

/* functions */

void copy_array(int array_size, int *array_dest, int* array_src)
{int i;
 for (i = 0; i<array_size; i++) array_dest[i] = array_src[i];}

void rotate_array(int *array, int number_to_move, int array_size)
{ int i, *temp_place;
  temp_place = malloc(array_size*sizeof(int));
  if (!temp_place) panic("allocation error 1 in snake_set_height_width");
  for (i = 0; i<array_size; i++) temp_place[i] = array[i];
  for (i = 0; i<array_size; i++)
    { array[i] = temp_place[(i+number_to_move)%array_size];}
  free(temp_place);}

float pass_best_option_to_contour(struct iteration_point *last_points,
				  int number_of_options)
     /* pass all the final options chuse the best of them and pass it to
	the global contours */
{ int i, local_place;
  float min_energy;
  local_place = 0;
  min_energy = last_points[0].min_energy;
  for (i = 1; i<number_of_options; i++)
    { if (last_points[i].min_energy<min_energy)
	/* replace the best option */
	{ local_place = i;
	  min_energy = last_points[i].min_energy;}}
  printf("the final resault is: \n");
  for (i = 0; i<gii; i++)
    { gcontour_y[i] = last_points[local_place].y_points_place[i];
      gcontour_x[i] = last_points[local_place].x_points_place[i];
      printf("(%d,%d) ", gcontour_x[i], gcontour_y[i]);}
  printf("\nThe minimum energy is: %f \n", min_energy);
  fflush(stdout);
  return min_energy;}

void print_contour(void)
{ int i;
  printf("The contour points are");
  for (i = 0; i<gii; i++) printf(" (%d,%d)", gcontour_x[i], gcontour_y[i]);
  printf("\n");}

void snake_set_height_width(int height, int width)
{ int y;
  gwidth = width;
  gheight = height;
  gpgm = (int **)malloc(height*sizeof(int *));
  if (!gpgm) panic("allocation error 1 in snake_set_height_width");
  for (y = 0; y<height; y++)
    { gpgm[y] = (int *)malloc(width*sizeof(int));
      if (!gpgm[y]) panic("allocation error 2 in snake_set_height_width");}}

void set_pixel(int y, int x, int pixel)
{ gpgm[y][x] = pixel;}

void set_ii(int ii)
{ gii = ii;
  gcontour_y = (int *)malloc(gii*sizeof(int));
  if (!gcontour_y) panic("allocation error 1 in set_ii");
  gcontour_x = (int *)malloc(gii*sizeof(int));
  if (!gcontour_x) panic("allocation error 2 in set_ii");}

void set_contour(int k, int y, int x)
{ gcontour_y[k] = y;
  gcontour_x[k] = x;}

int get_contour_x(int k)
{ return gcontour_x[k];}

int get_contour_y(int k)
{ return gcontour_y[k];}

void snake_free_all(void)
{ int y;
  for (y = 0; y<gheight; y++) free(gpgm[y]);
  free(gpgm);
  free(gcontour_y);
  free(gcontour_x);}

float del_i_y(int y, int x)
{ return ((gpgm[y+1][x]+gpgm[y+1][x+1])-(gpgm[y][x]+gpgm[y][x+1]))/2.0;}

float del_i_x(int y, int x)
{ return ((gpgm[y][x+1]+gpgm[y+1][x+1])-(gpgm[y][x]+gpgm[y+1][x]))/2.0;}

float edge_directed(int y0, int x0, int y1, int x1)
{ float r = 0.0, t, y, x, yy, xx;
  int ti, n = 10;
#ifdef DEBUG
  printf("edge of (%d,%d)-(%d,%d)", y0, x0, y1, x1);
#endif
  if ((y1==y0)&&(x1==x0)) return 0;
  for (ti = 0, t = 0.0; ti<n; ti++, t += 1.0/n)
    { y = y0+t*(y1-y0);
      x = x0+t*(x1-x0);
      yy = y1-y0;
      xx = x1-x0;
      r += fabs(del_i_y(y, x)*xx-del_i_x(y, x)*yy)/(sqrt(xx*xx+yy*yy)*n);}
  return -r;}

float edge(int y0, int x0, int y1, int x1)
{ float r = 0.0, t, y, x;
  int ti, n = 10;
  for (ti = 0, t = 0.0; ti<n; ti++, t += 1.0/n)
    { y = y0+t*(y1-y0);
      x = x0+t*(x1-x0);
      r += sqr(del_i_y(y, x))+sqr(del_i_x(y, x));}
  return -r;}

float econ(int y0, int x0, int y1, int x1, float average_length)
{ return 0.1*sqr(sqrt(sqr(y1-y0)+sqr(x1-x0))-average_length);}

float eline(int y0, int x0, int y1, int x1)
{ float r = 0.0, t;
  int ti, y, x, n = 10;
  for (ti = 0, t = 0.0; ti<n; ti++, t += 1.0/n)
    { y = y0+t*(y1-y0);
      x = x0+t*(x1-x0);
      r += gpgm[y][x];}
  return -r;}

float snake_e(int y0, int x0, int y1, int x1, int y2, int x2,
	      float c_edge_directed, float c_edge, float c_econ, float c_eline,
	      float average_length)
{ if ((y0==y1)&&(x0==x1)) return 0;
  return c_edge_directed*edge_directed(y0, x0, y1, x1)+
    c_edge*edge(y0, x0, y1, x1)+
      c_econ*econ(y0, x0, y1, x1, average_length)+
	c_eline*eline(y0, x0, y1, x1);}

float c_open_step(int width, int height, float c_edge_directed, float c_edge,
		  float c_econ, float c_eline, float average_length)
{ struct iteration_point *previous_points, *current_points, *temp_points;
  int contour_point, j, x, y, index, temp_point, possible_point;
  int previous_point;
  int previous_number_of_options = 0, current_number_of_options = 0;
  float temp_min_energy;
  int number_of_options = (2*width+1)*(2*width+1);
  previous_points = (struct iteration_point *)
    malloc(number_of_options*sizeof(struct iteration_point));
  if (!previous_points) panic("allocation error 1 in c_closed");
  current_points = (struct iteration_point *)
    malloc(number_of_options*sizeof(struct iteration_point));
  if (!current_points) panic("allocation error 2 in c_closed");
  for (j = 0; j<number_of_options; j++)
    { current_points[j].x_points_place = (int *)malloc(gii*sizeof(int));
      if (!current_points[j].x_points_place)
	{ panic("alloca error 3 in c_closed");}
      current_points[j].y_points_place = (int *)malloc(gii*sizeof(int));
      if (!current_points[j].y_points_place)
	{ panic("alloca error 3 in c_closed");}
      previous_points[j].x_points_place = (int *)malloc(gii*sizeof(int));
      if (!previous_points[j].x_points_place)
	{ panic("alloc error 4 in c_closed");}
      previous_points[j].y_points_place = (int *)malloc(gii*sizeof(int));
      if (!previous_points[j].y_points_place)
	{ panic("alloc error 5 in c_closed");}}
  /* prepare the first point */
  printf("the first points are: ");
  for (j = 0; j<gii; j++) printf("(%d,%d) ", gcontour_x[j], gcontour_y[j]);
  printf("\n");fflush(stdout);
  for (x = MAX(-width, 1-gcontour_x[0]), index = 0;
       x<=MIN(width, gwidth-2-gcontour_x[0]);
       x++)
    { for (y = MAX(-width, 1-gcontour_y[0]);
	   y<=MIN(width, height-2-gcontour_y[0]);
	   y++, index++)
	{ previous_points[index].y_points_place[0] = gcontour_y[0]+y;
	  previous_points[index].x_points_place[0] = gcontour_x[0]+x;
	  previous_points[index].min_energy = 0.0;}}
  previous_number_of_options = index;
  /* caluclate all the points */
  for (contour_point = 1; contour_point<gii; contour_point++)
    /* place all the points in there places */
    { for (x = MAX(-width, 1-gcontour_x[contour_point]), index = 0;
	   x<=MIN(width, gwidth-2-gcontour_x[contour_point]);
	   x++)
	for (y = MAX(-width, 1-gcontour_y[contour_point]);
	     y<=MIN(width, height-2-gcontour_y[contour_point]);
	     y++, index++)
	{ current_points[index].y_points_place[contour_point] =
	    gcontour_y[contour_point]+y;
	  current_points[index].x_points_place[contour_point] =
	    gcontour_x[contour_point]+x;}
	current_number_of_options = index;
	/* for each possible point place find the best place */
	for (possible_point = 0; possible_point<current_number_of_options;
	     possible_point++)
	{ float temp_min_energy;
	  int temp_place, i;
	  temp_place = 0;
	  temp_min_energy =
	  snake_e(current_points[possible_point].y_points_place[contour_point],
		  current_points[possible_point].x_points_place[contour_point],
		  previous_points[0].y_points_place[contour_point-1],
		  previous_points[0].x_points_place[contour_point-1],
		  0, 0, c_edge_directed, c_edge, c_econ, c_eline,
		  average_length)+previous_points[0].min_energy;
	  for (i = 1; i<previous_number_of_options; i++)
	  { float energy =
	    snake_e(current_points[possible_point].y_points_place[contour_point],
		    current_points[possible_point].x_points_place[contour_point],
		    previous_points[i].y_points_place[contour_point-1],
		    previous_points[i].x_points_place[contour_point-1],
		    0, 0, c_edge_directed, c_edge, c_econ, c_eline,
		    average_length)+previous_points[i].min_energy;
	      if (energy<temp_min_energy)
		{ temp_min_energy = energy;
		  temp_place = i;}}
	  /* now the best point is found copy the previous contour points*/
	  for (i = 0; i<contour_point; i++)
	    { current_points[possible_point].x_points_place[i] =
		previous_points[temp_place].x_points_place[i];
	      current_points[possible_point].y_points_place[i] =
		previous_points[temp_place].y_points_place[i];}
	  current_points[possible_point].min_energy = temp_min_energy;}
	temp_points = current_points;
	current_points = previous_points;
	previous_points = temp_points;
	previous_number_of_options = current_number_of_options;}
  temp_min_energy =
    pass_best_option_to_contour(temp_points, current_number_of_options);
  /* temp because of swapping */

  /* free memory */
 for (j = 0; j < number_of_options; j ++ )
   {
    free (current_points[j].x_points_place);
    free (current_points[j].y_points_place);
    free (previous_points[j].x_points_place);
    free (previous_points[j].y_points_place);
   } /* end of for */
   free (previous_points);
   free (current_points);
  return temp_min_energy;}

float c_open_snake(int width, int height, float c_edge_directed, float c_edge,
		   float c_econ, float c_eline, float average_length)
{ int i, number_of_steps, finished, *temp_contour_y, *temp_contour_x;
  float energy;
  temp_contour_y = (int *)malloc(gii*sizeof(int));
  if (!temp_contour_y) panic("alloca error 1 in c_open_snake");
  temp_contour_x = (int *)malloc(gii*sizeof(int));
  if (!temp_contour_x) panic("alloca error 2 in c_open_snake");
  for (number_of_steps = 0; number_of_steps<30; number_of_steps++)
    { for (i = 0; i<gii; i++)
	{ temp_contour_y[i] = gcontour_y[i];
	  temp_contour_x[i] = gcontour_x[i];}
      energy = c_open_step(width, height, c_edge_directed, c_edge,
			   c_econ, c_eline, average_length);
      finished = 1;
      for (i = 0; ((i<gii)&&(finished==1)); i++)
	if ((gcontour_y[i]!=temp_contour_y[i])||
	    (gcontour_x[i]!=temp_contour_x[i]))
	  finished = 0;
      /* get out of the for loop */
      if (finished==1) break;}
  if (finished==0)
    { printf("WARNING!: open snake loop was exited because of maximum tries");}
  free(temp_contour_y);
  free(temp_contour_x);
  return energy;}

float c_closed_snake(int width, int height,
		     float c_edge_directed, float c_edge,
		     float c_econ, float c_eline, float average_length)
{ int i, number_of_steps, finished = 0, min_energy_place = 0;
  int number_of_rotations = 0;
  float previous_energy, energy;
  int *temp_contour_y, *temp_contour_x;
  temp_contour_y = (int *)malloc(gii*sizeof(int));
  if (!temp_contour_y) panic("alloca error 1 in c_open_snake");
  temp_contour_x = (int *)malloc(gii * sizeof(int));
  if (!temp_contour_x) panic("alloca error 2 in c_open_snake");
  previous_energy =
    c_open_step(width, height, c_edge_directed, c_edge, c_econ, c_eline,
		average_length)+
		  snake_e(gcontour_y[0],
			  gcontour_x[0],
			  gcontour_y[gii-1],
			  gcontour_x[gii-1],
			  0, 0, c_edge_directed, c_edge, c_econ, c_eline,
			  average_length);
  copy_array(gii, temp_contour_y, gcontour_y);
  copy_array(gii, temp_contour_x, gcontour_x);
  rotate_array(gcontour_y, 1, gii);
  rotate_array(gcontour_x, 1, gii);
  for (number_of_steps = 0; number_of_steps<50; number_of_steps++)
    { energy =
	c_open_step(width, height, c_edge_directed, c_edge,
		    c_econ, c_eline, average_length)+
		      snake_e(gcontour_y[0],
			      gcontour_x[0],
			      gcontour_y[gii-1],
			      gcontour_x[gii-1],
			      0, 0, c_edge_directed, c_edge, c_econ, c_eline,
			      average_length);
      if (energy+0.01<previous_energy)
	/* copy the place */
	{ copy_array(gii, temp_contour_y, gcontour_y);
	  copy_array(gii, temp_contour_x, gcontour_x);
	  min_energy_place = number_of_rotations;
	  printf("!found new_energy. previous_energy = %f new energy = %f!!\n",
		 previous_energy,energy);
	  previous_energy = energy;}
      if (min_energy_place<=number_of_rotations-gii) finished = 1;
      if (finished==1 ) break;	/* get out of the for loop */
      number_of_rotations++;
      rotate_array(gcontour_y, 1, gii);
      rotate_array(gcontour_x, 1, gii);}
  if (finished==0)
    { printf("WARNING!!: open snake loop was exited because of maximum tries");
      fflush(stdout);}
  copy_array(gii, gcontour_y, temp_contour_y);
  copy_array(gii, gcontour_x, temp_contour_x);
  return previous_energy;}
