(MODULE HLIB-SNAKE)
;;; LaHaShem HaAretz U'Mloah

(include "QobiScheme.sch")
(include "hlib-snake.sch")
(include "c-externals.sc")

;;; Procedures

(define (set-pgm! pgm)
 (let ((grey (pgm-grey pgm)))
  (snake:set-height-width! (pnm-height pgm) (pnm-width pgm))
  (do ((y 0 (+ y 1))) ((= y (pnm-height pgm)))
   (do ((x 0 (+ x 1))) ((= x (pnm-width pgm)))
    (set-pixel! y x (matrix-ref grey y x )))))
 #f)

(define (pass-contour! points)
 (let ((contour-y (list->vector (map y points)))
       (contour-x (list->vector (map x points))))
  (set-ii! (length points))
  (do ((i 0 (+ i 1))) ((= i (length points)) #f)
   (set-contour! i (vector-ref contour-y i) (vector-ref contour-x i)))))

(define (get-contour points)
 (let ((points-length (length points))
       (points '()))
  (do ((i 0 (+ i 1))) ((= i points-length) (reverse points))
   (set! points (cons (vector (get-contour-x i) (get-contour-y i)) points)))))

(define (contour-length contour)
 (define (contour-length1 contour size-so-far)
  (if (> (length contour) 2)
      (contour-length1
       (rest contour)
       (+ size-so-far (distance (first contour) (second contour))))
      (+ size-so-far (distance (first contour) (second contour)))))
 (if (> (length contour) 2)
     (contour-length1 contour (distance (first contour) (last contour)))
     (distance (first contour) (last contour))))

(define (open-step pgm width contour
		   edge-directed edge econ eline average-length)
 (let ((energy (c-open-step width (pnm-height pgm)
			    edge-directed edge econ eline average-length)))
  (list energy (get-contour contour))))

(define (open-snake pgm width contour
		    edge-directed edge econ eline average-length)
 (set-pgm! pgm)
 (pass-contour! contour)
 (let* ((energy (c-open-snake width (pnm-height pgm)
			      edge-directed edge econ eline average-length))
	(contour (get-contour contour)))
  (snake:free-all)
  (list energy contour)))

(define (closed-snake pgm width contour
		      edge-directed edge econ eline average-length)
 (set-pgm! pgm)
 (pass-contour! contour)
 (let* ((energy (c-closed-snake width (pnm-height pgm)
				edge-directed edge econ eline average-length))
	(contour (get-contour contour)))
  (snake:free-all)
  (list energy contour)))

;;; Tam V'Nishlam Shevah L'El Borei Olam
