#ifndef _hmm_h
#define _hmm_h

#include <stdio.h>
#include "hlib-c.h"

typedef struct {
  RMat logA;
  RVec logB;
  int uu;
} Hmm;

#define HMM_STATES(x) ((x)->uu)

/* -- utility functions -- */

extern Hmm *allocHMM(int uu);
extern void copyHMM(Hmm *m1, Hmm *m2);
extern void displayHMM(FILE *f, Hmm *m);
extern void freeHMM(Hmm *m);
extern void normaliseHMM(Hmm *m);
extern void randomiseHMM(Hmm *m, int flags);
extern void zeroHMM(Hmm *m);

/* -- processing functions -- */

extern void HMM_calcAlphas(Hmm *m, RVec *logL);
extern void HMM_calcDeltas(Hmm *m, RVec *logL);
extern Real HMM_logL(Hmm *m, RVec *logL);
extern int *HMM_best_state_sequence(Hmm *m, RVec *logL);
extern Real HMM_updateModel(Hmm *m, Hmm *new, RVec *logL, RVec *gamma);

#endif
