(MODULE
 TRACKER
 (WITH
  QOBISCHEME
  XLIB
  HLIB-CHANGE-MOVIE
  HLIB-EM
  HLIB-FIND-LINES
  HLIB-HULL
  HLIB-INTERPRET
  HLIB-KINEMATIC
  HLIB-LOCATE
  HLIB-MERGE-LINES
  HLIB-MOST
  HLIB-POSTSCRIPT
  HLIB-RATIO-REGIONS
  HLIB-RILIB
  HLIB-SDE
  HLIB-SNAKE
  HLIB-SPAN
  HLIB-SPEAK
  HLIB-TRACK
  HLIB-TRAIN-CLASSIFY
  HLIB-WBM)
 (MAIN MAIN))
;;; LaHaShem HaAretz U'Mloah

(include "QobiScheme.sch")
(include "tracker.sch")
(include "c-externals.sc")

(set! *program* "tracker")
(set! *panic?* #t)

;;; Variables

(define *fill* #f)
(define *x-weight* #f)
(define *y-weight* #f)
(define *t-weight* #f)
(define *a-weight* #f)
(define *b-weight* #f)
(define *correspondence-threshold* #f)
(define *red?* #f)
(define *green?* #f)
(define *blue?* #f)
(define *yellow?* #f)
(define *rhl* 13)
(define *rhh* 336)
(define *rsl* 36)
(define *rsh* 74)
(define *rvl* 35)
(define *rvh* 70)
(define *ghl* 122)
(define *ghh* 164)
(define *gsl* 29)
(define *gsh* 71)
(define *gvl* 22)
(define *gvh* 55)
(define *bhl* 192)
(define *bhh* 227)
(define *bsl* 32)
(define *bsh* 66)
(define *bvl* 27)
(define *bvh* 61)
(define *yhl* 50)
(define *yhh* 70)
(define *ysl* 40)
(define *ysh* 65)
(define *yvl* 55)
(define *yvh* 80)
(define *meteor-motion-threshold* 24)
(define *meteor-colour-pixel-mass-threshold* 60)
(define *meteor-colour-proximity-threshold* 4)
(define *meteor-motion-pixel-mass-threshold* 200)
(define *meteor-motion-proximity-threshold* 8)

;;; Top Level

(define-command
 (main (at-most-one ("rgby" rgby? (rgby "pathname" string-argument "rgby")))
       (at-most-one ("uninterlaced" uninterlaced?))
       (at-most-one ("code" capturing-code?))
       (at-most-one ("ellipses" tracking-ellipses?))
       (at-most-one ("polygons" tracking-polygons?))
       (at-most-one ("hull" hull?))
       (at-most-one ("corresponded" corresponded?))
       (at-most-one ("fill" fill? (fill "#" integer-argument 5)))
       (at-most-one ("x-weight" x-weight? (x-weight "#" real-argument 1.0)))
       (at-most-one ("y-weight" y-weight? (y-weight "#" real-argument 1.0)))
       (at-most-one ("a-weight" a-weight? (a-weight "#" real-argument 1.0)))
       (at-most-one
	("correspondence-threshold"
	 correspondence-threshold?
	 (correspondence-threshold "#" real-argument 0.15)))
       (required (pathname "pathname" string-argument)))
 (set! *red?* #t)
 (set! *green?* #t)
 (set! *blue?* #t)
 (set! *yellow?* #t)
 (when rgby?
  (let ((rgby (read-object-from-file (default-extension rgby "rgby"))))
   (set! *red?* (first (first rgby)))
   (set! *rhl* (second (first rgby)))
   (set! *rhh* (third (first rgby)))
   (set! *rsl* (fourth (first rgby)))
   (set! *rsh* (fifth (first rgby)))
   (set! *rvl* (sixth (first rgby)))
   (set! *rvh* (seventh (first rgby)))
   (set! *green?* (first (second rgby)))
   (set! *ghl* (second (second rgby)))
   (set! *ghh* (third (second rgby)))
   (set! *gsl* (fourth (second rgby)))
   (set! *gsh* (fifth (second rgby)))
   (set! *gvl* (sixth (second rgby)))
   (set! *gvh* (seventh (second rgby)))
   (set! *blue?* (first (third rgby)))
   (set! *bhl* (second (third rgby)))
   (set! *bhh* (third (third rgby)))
   (set! *bsl* (fourth (third rgby)))
   (set! *bsh* (fifth (third rgby)))
   (set! *bvl* (sixth (third rgby)))
   (set! *bvh* (seventh (third rgby)))
   (set! *yellow?* (first (fourth rgby)))
   (set! *yhl* (second (fourth rgby)))
   (set! *yhh* (third (fourth rgby)))
   (set! *ysl* (fourth (fourth rgby)))
   (set! *ysh* (fifth (fourth rgby)))
   (set! *yvl* (sixth (fourth rgby)))
   (set! *yvh* (seventh (fourth rgby)))
   (set! *meteor-motion-threshold* (first (fifth rgby)))
   (set! *meteor-colour-pixel-mass-threshold* (second (fifth rgby)))
   (set! *meteor-colour-proximity-threshold* (third (fifth rgby)))
   (set! *meteor-motion-pixel-mass-threshold* (fourth (fifth rgby)))
   (set! *meteor-motion-proximity-threshold* (fifth (fifth rgby)))
   (meteor-set-red-hack-track!
    *rhl* *rhh* (if *red?* *rsl* 101) *rsh* *rvl* *rvh*)
   (meteor-set-green-hack-track!
    *ghl* *ghh* (if *green?* *gsl* 101) *gsh* *gvl* *gvh*)
   (meteor-set-blue-hack-track!
    *bhl* *bhh* (if *blue?* *bsl* 101) *bsh* *bvl* *bvh*)
   (meteor-set-yellow-hack-track!
    *yhl* *yhh* (if *yellow?* *ysl* 101) *ysh* *yvl* *yvh*)
   (meteor-set-hack-track! *meteor-motion-threshold*
			   *meteor-colour-pixel-mass-threshold*
			   *meteor-colour-proximity-threshold*
			   *meteor-motion-pixel-mass-threshold*
			   *meteor-motion-proximity-threshold*)))
 (set! *fill* fill)
 (set! *x-weight* x-weight)
 (set! *y-weight* y-weight)
 (set! *a-weight* a-weight)
 (set! *correspondence-threshold* correspondence-threshold)
 (let* ((video-type (if (has-extension? pathname) (extension pathname) "Jpeg"))
	(result (meteor-track-video-file pathname
					 video-type
					 uninterlaced?
					 capturing-code?
					 capturing-code?
					 tracking-ellipses?
					 tracking-polygons?
					 hull?
					 #t
					 *meteor-motion-threshold*
					 *meteor-colour-pixel-mass-threshold*
					 *meteor-colour-proximity-threshold*
					 *meteor-motion-pixel-mass-threshold*
					 *meteor-motion-proximity-threshold*)))
  (when tracking-ellipses?
   (let* ((ellipse-movie (first result))
	  (ellipse-movie
	   (if corresponded?
	       (internal-correspondence
		ellipse-movie
		*fill*
		*x-weight*
		*y-weight*
		*t-weight*
		*a-weight*
		*b-weight*
		*correspondence-threshold*)
	       ellipse-movie)))
    (write-object-to-file
     ellipse-movie (replace-extension pathname "ellipse-movie"))))
  (when tracking-polygons?
   (let* ((polygon-movie (convex-hull-of-polygon-movie (second result)))
	  (polygon-movie
	   (map-vector (lambda (frame) (map vector->list (vector->list frame)))
		       polygon-movie))
	  (polygon-movie
	   (if corresponded?
	       (polygon-correspondence
		polygon-movie
		*fill*
		*x-weight*
		*y-weight*
		*a-weight*
		*correspondence-threshold*)
	       polygon-movie))
	  (polygon-movie
	   (map-vector
	    (lambda (frame) (map list->vector frame)) polygon-movie)))
    (write-object-to-file
     polygon-movie (replace-extension pathname "polygon-movie")))))
 #f)

;;; Tam V'Nishlam Shevah L'El Borei Olam
